local SMM = {
	Event = {},
	data = {
		playerID = nil,
		playerZONE="",
		update = false,
		enable = false,
		Autotrack ={},
	},
	 
}
--SMMnodes -> zone -> resource -> coord list
--SMMnodes.freemarch.tin ={coord, coord, coord}
local SMMnodes = {}
local bagINI = false
local Inventory = {}
local function startInv()
	local bag, idx
	for bag=1, 5 do
		for idx=1, 32 do
			slot = Utility.Item.Slot.Inventory(bag , idx)
			item=Inspect.Item.Detail(slot)
			Inventory[slot]=item
			if item then
		
				bagINI=true
			end
		end
	end
end


local function unitAvailable(handle, units)
	for k, v in pairs(units) do
		if(v == "player") then
		SMM.data.enable = true
		if not bagINI then 
		startInv()
end
		end 
		end 
		end
		
local function unitNotAvailable(handle, units)
	for k, v in pairs(units) do
		if(v == "player") then
		SMM.data.enable = false
		end 
		end 
		end






local function mapIT(name, xs, ys,  zs, comment)
	
	SMM.data.playerZONE = Inspect.Zone.Detail(Inspect.Unit.Detail("player").zone).name
	
	if not SMMnodes[SMM.data.playerZONE] then
		SMMnodes[SMM.data.playerZONE]={}
		end
	if not SMMnodes[SMM.data.playerZONE][name] then
		SMMnodes[SMM.data.playerZONE][name]={}
	end
	
		if not Ignore_Map[SMM.data.playerZONE] then
		Ignore_Map[SMM.data.playerZONE]={}
		end
	if not Ignore_Map[SMM.data.playerZONE][name] then
		Ignore_Map[SMM.data.playerZONE][name]={}
	end
	
	
	local playerdetail=Inspect.Unit.Detail("player")
	if not playerdetail then return end
	local found = false
	local i, d
	local x,z
	
	if xs~=nil then x=tonumber(xs)	else x=playerdetail.coordX end
	if ys~=nil then y=tonumber(ys)	else y=playerdetail.coordY end
	if zs~=nil then z=tonumber(zs)	else z=playerdetail.coordZ end

		for i, d in ipairs (Ignore_Map[SMM.data.playerZONE][name]) do
		if  ((x-d[1])*(x-d[1])+
			(y-d[2])*(y-d[2])+
		    (z-d[3])*(z-d[3])) < 10 then
		    
		    return 
			
		end
	end
	
	
	for i, d in ipairs (SMMnodes[SMM.data.playerZONE][name]) do
		if  ((x-d[1])*(x-d[1])+
			(y-d[2])*(y-d[2])+
		    (z-d[3])*(z-d[3])) < 10 then
		    d[4]=(d[4] or 1)+1
		    found = true
			
		end
	end
	if found and ((table.getn(SMMnodes[SMM.data.playerZONE][name]) > 1) or name ~= "misc collectible") then print("Duplicate Node") end
	if not found then
		
			
		
		table.insert(SMMnodes[SMM.data.playerZONE][name],
			{ x, y, z, 1, comment }
		)
		
		
		print(SMM.data.playerZONE .. ": " ..tostring(table.getn(SMMnodes[SMM.data.playerZONE][name])) .. " " .. name .. " nodes known ")
		
		
		
	end
end

SMM.data.Autotrack =
{
["Coastal Glory"] = 1,
["Grieveblossom"] = 1,
["Bloodbriar"] = 1,
["Yew Log"] = 1,
["Corpseblossom"] = 1,
["Creeperbrush"] = 1,
["Ashwood Log"] = 1,
["Razorbrush"] = 1,
["Krakenweed"] = 1,
["Oak Log"] = 1,
["Golden Nettle"] = 1,
["Duskglory"] = 1,
["Mahogany Log"] = 1,
["Wyvernspurr"] = 1,
["Tattertwist"] = 1,
["Roc Orchid"] = 1,
["Kingswood Log"] = 1,
["Drakefoot"] = 1,
["Runebirch Log"] = 1,
["Bloodshade"] = 1,
["Basiliskweed"] = 1,
["Sagebrush Log"] = 1,
["Tempestflower"] = 1,
["Twilight Bloom"] = 1,
["Shadethorn Branch"] = 1,
["Chimera's Cloak"] = 1,
["Linden Timber"] = 1,
["Frazzleweed"] = 1,
["Elm Timber"] = 1,
["Madrosa Timber"] = 1,
["Lucidflower"] = 1,
["Tin Lode"] = 1,
["Copper Vein"] = 1,
["Iron Vein"] = 1,
["Silver Vein"] = 1,
["Chromite Vein"] = 1,
["Cobalt Lode"] = 1,
["Gold Vein"] = 1,
["Titanium Vein"] = 1,
["Carmintium Deposit"] = 1,
["Platinum Deposit"] = 1,
["Orichalcum Deposit"] = 1,
["Orichalcum"] = 1,
["Gantimite Vein"] = 1,
["Karthite Vein"] = 1,
["Rhenium Vein"] = 1,
["School of Fish"] = 1,
["School of Clever Fish"] = 1,
["School of Rare Fish"] = 1,
["Sunken Boat"] = 1,
}



function SMM.Event_Map_Add(h,e)
	for k,v in pairs(Inspect.Map.Detail(e)) do
	
	if SMM.data.Autotrack[v.description] then
		print("Auto Mapped "..v.description)
		mapIT(v.description, v.coordX, v.coordY, v.coordZ, "TrackMapped2.10+")
		end
	end
	end



function SMM.Event.ItemAdjust(updates)
if  Inspect.Interaction("auction")
or  Inspect.Interaction("bank")
or  Inspect.Interaction("guildbank")
or  Inspect.Interaction("mail") then 

--print("fail")
return end


if SMM.data.update and SMM.data.enable then

if not bagINI then 
--print("Bag Fail")
startInv()
end

	local k, v
	for k, v in pairs(updates) do

		if k:sub(1, 2) == "si" 
		and k:sub(1, 4) ~= "sibg"
		and v ~= false and v ~= nil and v ~= "nil" then
			local itemdetail=Inspect.Item.Detail(v)

			if itemdetail.category == "misc collectible"
			
			and (								
			   not Inventory[k] 									
			   or (Inventory[k].id == itemdetail.id and Inventory[k].stack ~= itemdetail.stack) 
			) then
				mapIT(itemdetail.category, nil, nil, nil, itemdetail.name)
				
			end
			Inventory[k]=itemdetail
		else
			Inventory[k]=nil
		end
	end
	end
end






function SMM.Event.LoadEnd(identifier)
	if identifier == "SINMapMaker" then
		SMM.data.playerID = Inspect.Unit.Lookup("player")
		
		--startInv()
		print("SINMapMaker loaded. /SMM")
		SMM.data.update = true
	end
end



--for key, node in pairs(SMMnodes) do

local function AddDragFrame(window)

  function window.Event:LeftDown()
    self.leftDown = true
    local mouse = Inspect.Mouse()
    self.originalXDiff = mouse.x - self:GetLeft()
    self.originalYDiff = mouse.y - self:GetTop()
    local left, top, right, bottom = window:GetBounds()
    window:ClearAll()
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", left, top)
    window:SetWidth(right-left)
    window:SetHeight(bottom-top)
  end

  function window.Event:LeftUp()
    self.leftDown = false
  end

  function window.Event:LeftUpoutside()
    self.leftDown = false
  end

  function window.Event:MouseMove(x, y)
    if not self.leftDown then
      return
    end
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x - self.originalXDiff, y - self.originalYDiff)
	SMM.data.meter_x = x - self.originalXDiff
	SMM.data.meter_y = y - self.originalYDiff
  end
end

-- start frames
local main = UI.CreateContext("UI")
local box = UI.CreateFrame("Frame", "box", main)
local ticker = UI.CreateFrame("Text", "Ticker", box)

box:SetPoint("CENTER",UIParent,"CENTER",100,100)
box:SetWidth(250)
box:SetHeight(40)
box:SetAlpha(.6)
box:SetVisible(false)
box:SetBackgroundColor(0,0,0)

ticker:SetText(" 0 : 0 : 0 ")
ticker:SetPoint("CENTER",box,"CENTER",0,0)
ticker:SetFontSize(25)

AddDragFrame(box)


local lastCall = Inspect.Time.Real()
function SMM.Event.Update()

if SMM.data.update  and SMM.data.enable then
local now = Inspect.Time.Real()
	if (now<lastCall+.20) then 
		return
	end



if(Inspect.Unit.Detail(SMM.data.playerID).coordX)then
SMM.data.playerX = math.floor(Inspect.Unit.Detail(SMM.data.playerID).coordX)
SMM.data.playerY = math.floor(Inspect.Unit.Detail(SMM.data.playerID).coordY)
SMM.data.playerZ = math.floor(Inspect.Unit.Detail(SMM.data.playerID).coordZ)
ticker:SetText(SMM.data.playerX.." : ".. SMM.data.playerY.." : ".. SMM.data.playerZ)
end

lastCall = now
end

end


function SMM.Event.save()
if SMMnodes then
 SINMapMaker_Export_Map = SMMnodes
 
end

   end

function SMM.Event.load()
if SINMapMaker_Export_Map then
SMMnodes = SINMapMaker_Export_Map
end


   end

function SMM.Event.SlashHandler(str)
	
	local cmd, arg = string.match(str, "(%a+) ?(.*)")
	
	local playerZONE = Inspect.Zone.Detail(Inspect.Unit.Detail("player").zone).name
	
	if playerZONE ==nil then print("nil zone") return end
	
	if not SMMnodes[playerZONE] then
		SMMnodes[playerZONE]={}
		end
		
		local zonemap = 0
for i, d in pairs (SMMnodes[playerZONE]) do

	print(i .. " : " .. tostring(table.getn(SMMnodes[playerZONE][i])))
	
	--print(SMM.data.playerZONE .. ": " ..tostring(table.getn(SMMnodes[SMM.data.playerZONE][name])) .. " " .. name .. " nodes known ")
	
	
	zonemap = zonemap + table.getn(SMMnodes[playerZONE][i])
	
	
	end
	print("Total Nodes in " .. playerZONE .." : " .. tostring(zonemap))
	
	
	
	end
	
	
	
	
	
	
	

--inventory f(X)	
table.insert(Event.Item.Slot,   		{SMM.Event.ItemAdjust, "SINMapMaker", "ItemSlotUpdated"})
table.insert(Event.Item.Update, 		{SMM.Event.ItemAdjust, "SINMapMaker", "ItemUpdated"})
   
Command.Event.Attach(Event.Unit.Availability.Full, unitAvailable, "unitAvailable")
Command.Event.Attach(Event.Unit.Availability.None, unitNotAvailable, "unitNotAvailable")
Command.Event.Attach(Event.Unit.Availability.Partial, unitNotAvailable, "unitNotAvailable")
Command.Event.Attach(Event.Map.Add, SMM.Event_Map_Add, "Event.Map.Add")



table.insert(Event.System.Update.Begin, {SMM.Event.Update, "SINMapMaker", "fade"})
table.insert(Event.Addon.SavedVariables.Save.Begin, {SMM.Event.save, "SINMapMaker", "Save variables"})
table.insert(Event.Addon.SavedVariables.Load.End, {SMM.Event.load, "SINMapMaker", "Load variables"})
table.insert(Event.Addon.Load.End, 				{SMM.Event.LoadEnd, 			"SINMapMaker", "Init"})
table.insert(Command.Slash.Register("SMM"), 		{SMM.Event.SlashHandler, 	"SINMapMaker", "Slash"})